Subject: bug#49963: 28.0.50; isearch failing in Dired after rectangle-mark-mode and query-replace

From: Eli Zaretskii <[email-masked]>
Date: Tue, 10 Aug 2021 19:42:17 +0300

> From: Stefan Monnier <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>,  [email-masked],  [email-masked],
>   [email-masked]
> Date: Tue, 10 Aug 2021 11:56:58 -0400
> 
> Lars Ingebrigtsen [2021-08-10 17:44:50] wrote:
> > Eli Zaretskii <[email-masked]> writes:
> >> I meant can we please not use add-function and friends.  Please?
> > There isn't much difference between using add-function and add-hook most
> > of the time (although here we trip over a `let' binding not doing what
> > the author thought it did).
> 
> FWIW, `add-hook` has the exact same problem with `let` (and we already
> tripped against this exact same situation with `add-hook` and `let`).

This is a misunderstanding of what bothers me.  The problem is
discoverability: add-function is not easily discoverable, if it is
used on an internal function.  IOW, the documentation of C-s doesn't
tell you that its operation could be affected by that "hook".  By
contrast, if we use some other mechanism, like call a function via a
variable or call a hook, and if we document these in the doc string of
C-s, that problem will have disappeared, and finding causes of
problems such as this one would be easier.